//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * キャラクタモデルヘッダ
 * @author Junpee
 */

#ifndef CHARACTER_MODEL_H_
#define CHARACTER_MODEL_H_

#include <Graphics/Model/Model.h>
#include <Graphics/Model/Bone.h>

namespace Lamp{

//------------------------------------------------------------------------------
/**
 * キャラクタモデル
 */
class CharacterModel : public Model{
friend class ModelManager;
public:
	//--------------------------------------------------------------------------
	/// 最大ボーン数
	static const int maxBoneCount = 64;

	//--------------------------------------------------------------------------
	/**
	 * キャラクタモデルかどうか
	 * @return キャラクタモデルならtrue
	 */
	virtual bool isCharacterModel() const{ return true; }

	//--------------------------------------------------------------------------
	/**
	 * コピー
	 * @param copyMask コピーマスク
	 * @return コピーされたシーンリーフ
	 */
	virtual SceneLeaf* copy(u_int copyMask = 0) const{
		return copyCharacterModel(copyMask);
	}

	/**
	 * モデルのコピー
	 * @param copyMask コピーマスク
	 * @return コピーされたモデル
	 */
	virtual Model* copyModel(u_int copyMask = 0) const{
		return copyCharacterModel(copyMask);
	}

	/**
	 * キャラクタモデルのコピー
	 * @param copyMask コピーマスク
	 * @return コピーされたモデル
	 */
	virtual CharacterModel* copyCharacterModel(u_int copyMask = 0) const;

	//--------------------------------------------------------------------------
	/**
	 * ボーン行列の構築
	 * @param forceCalculation 強制的に再計算する
	 */
	virtual void buildBoneMatrix(bool forceCalculation = false);

	/**
	 * ボーンにスケールが含まれるか
	 * @return ボーンにスケールが含まれるならtrue
	 */
	virtual bool isBoneScaled() const{ return boneScaled_; }

	//--------------------------------------------------------------------------
	/**
	 * 位置変形行列配列の取得
	 * @param forceCalculation 強制的に再計算する
	 * @return 位置変形行列配列
	 */
	virtual const Matrix34* getPositionDeformMatrixArray(
		bool forceCalculation = false);

	/**
	 * 法線変形行列配列の取得
	 * @param forceCalculation 強制的に再計算する
	 * @return 法線変形行列配列
	 */
	virtual const Matrix33* getNormalDeformMatrixArray(
		bool forceCalculation = false);

	//--------------------------------------------------------------------------
	// ボーンインターフェース
	//--------------------------------------------------------------------------
	/**
	 * ボーンの作成
	 *
	 * ボーンを作成し、ボーンリストの最後尾に追加します。
	 * すでに同じ名前のボーンが存在するとエラーになります。
	 * 空文字列を名前に指定するとエラーになります。
	 * @param boneName ボーン名
	 * @return 作成されたボーン
	 */
	virtual Bone* createBone(const String& boneName);

	/**
	 * ボーンの破棄
	 * @param bone 破棄するボーン
	 */
	virtual void destroyBone(Bone* bone);

	/**
	 * ボーンのクリア
	 * @return 削除したボーン数
	 */
	virtual int clearBone();

	/**
	 * ボーン数の取得
	 * @return ボーン数
	 */
	virtual int getBoneCount() const{ return boneArray_.getCount(); }

	/**
	 * ボーンの取得
	 * @param index ボーンのインデクス
	 * @return ボーン
	 */
	virtual Bone* getBone(int index) const{
		Assert(index >= 0);
		Assert(index < boneArray_.getCount());
		return boneArray_.get(index);
	}

	/**
	 * ボーンインデックスの取得
	 * @param bone ボーン
	 * @return ボーンインデックス。見つからなければ-1
	 */
	virtual int getBoneIndex(Bone* bone) const{
		int boneCount = getBoneCount();
		for(int i = 0; i < boneCount; i++){
			if(getBone(i) == bone){ return i; }
		}
		return -1;
	}

	/**
	 * ボーンの検索
	 * @param boneName 検索するボーン名
	 * @return ボーン
	 */
	virtual Bone* searchBone(const String& boneName) const{
		return boneHash_.get(boneName);
	}

	//--------------------------------------------------------------------------
	/**
	 * メッシュの追加
	 * @param mesh 追加するメッシュ
	 */
	virtual void addMesh(Mesh* mesh);

	//--------------------------------------------------------------------------
protected:
	/**
	 * コンストラクタ
	 * @param name 名前
	 * @param scene シーン
	 */
	CharacterModel(const String& name, Scene* scene);

	/**
	 * デストラクタ
	 */
	virtual ~CharacterModel();

	/**
	 * 変形行列配列の構築
	 */
	virtual void buildDeformMatrixArray();

	/// ボーンハッシュ
	HashMap<String, Bone*> boneHash_;
	/// ボーン配列
	ArrayList<Bone*> boneArray_;
	/// 位置変形行列配列
	Matrix34* positionDeformMatrixArray_;
	/// 法線変形行列配列
	Matrix33* normalDeformMatrixArray_;
	/// 変形行列配列サイズ
	int deformMatrixArraySize_;
	/// ボーン行列の構築チック
	int buildBoneMatrixTick_;
	/// 変形行列配列チック
	int deformMatrixArrayTick_;
	/// ボーンにスケールが含まれるか
	bool boneScaled_;

	//--------------------------------------------------------------------------
private:

};

//------------------------------------------------------------------------------
} // End of namespace Lamp
#endif // End of CHARACTER_MODEL_H_
//------------------------------------------------------------------------------

